{
  "custom": {},
  "params": {
    "configuring": false,
    "equipmentPath": "",
    "runLookbackCount": 0,
    "timePeriod": "",
    "title": "OEE Downtime table"
  },
  "propConfig": {
    "params.configuring": {
      "onChange": {
        "enabled": null,
        "script": "\tviewParams\u003dself.params\n\tconfigParams\u003dself.getChild(\"root/configuration\").props.params\n\tif currentValue.value:\n\t\tconfigParams.equipmentPathIn \u003d viewParams.equipmentPath\n\t\tconfigParams.timePeriodIn \u003d viewParams.timePeriod\n\t\tconfigParams.titleIn \u003d viewParams.title\n\telif previousValue is not None and previousValue.value:\n\t\tviewParams.equipmentPath \u003d configParams.equipmentPathOut\n\t\tviewParams.timePeriod \u003d configParams.timePeriodOut\n\t\tviewParams.title \u003d configParams.titleOut"
      },
      "paramDirection": "input",
      "persistent": true
    },
    "params.eqPath": {
      "onChange": {
        "enabled": null,
        "script": "\tif currentValue.value:\n\t\tself.getChild(\"root\").getChild(\"oeeDowntimeTable\").props.equipmentPath \u003d currentValue.value"
      },
      "paramDirection": "inout",
      "persistent": false
    },
    "params.equipmentPath": {
      "paramDirection": "inout",
      "persistent": true
    },
    "params.runLookbackCount": {
      "paramDirection": "inout",
      "persistent": true
    },
    "params.timePeriod": {
      "paramDirection": "inout",
      "persistent": true
    },
    "params.title": {
      "paramDirection": "inout",
      "persistent": true
    }
  },
  "props": {
    "defaultSize": {
      "height": 500,
      "width": 1200
    }
  },
  "root": {
    "children": [
      {
        "children": [
          {
            "meta": {
              "name": "oeeDowntimeTable"
            },
            "position": {
              "basis": "320px",
              "grow": 1
            },
            "propConfig": {
              "props.endDate": {
                "binding": {
                  "config": {
                    "fallbackDelay": 2.5,
                    "mode": "expression",
                    "tagPath": "runScript(\u0027shared.mes.schedule.getTagPathForTimePeriodEnd\u0027, 0, {view.params.timePeriod}, {view.params.equipmentPath})"
                  },
                  "overlayOptOut": true,
                  "type": "tag"
                },
                "persistent": false
              },
              "props.equipmentPath": {
                "binding": {
                  "config": {
                    "path": "view.params.equipmentPath"
                  },
                  "type": "property"
                },
                "persistent": false
              },
              "props.runLookBackCount": {
                "binding": {
                  "config": {
                    "path": "view.params.runLookbackCount"
                  },
                  "overlayOptOut": true,
                  "type": "property"
                },
                "persistent": true
              },
              "props.startDate": {
                "binding": {
                  "config": {
                    "fallbackDelay": 2.5,
                    "mode": "expression",
                    "tagPath": "runScript(\u0027shared.mes.schedule.getTagPathForTimePeriodStart\u0027,0, {view.params.timePeriod}, {view.params.equipmentPath})"
                  },
                  "overlayOptOut": true,
                  "type": "tag"
                },
                "persistent": false
              },
              "props.toolbarTitle": {
                "binding": {
                  "config": {
                    "path": "view.params.title"
                  },
                  "transforms": [
                    {
                      "expression": "upper({value})",
                      "type": "expression"
                    }
                  ],
                  "type": "property"
                }
              }
            },
            "props": {
              "data": {
                "$": [
                  "ds",
                  192,
                  1737765428325
                ],
                "$columns": []
              },
              "fillResizeMode": true,
              "multiSelect": true,
              "tableColumns": [
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "begin",
                  "dataFormat": "yyyy-MM-dd HH:mm:ss",
                  "dataType": "date",
                  "fixed": "none",
                  "hidden": false,
                  "include": true,
                  "name": "begin",
                  "order": 1,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Begin",
                  "width": 150,
                  "wordWrapEnabled": false
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "end",
                  "dataFormat": "yyyy-MM-dd HH:mm:ss",
                  "dataType": "date",
                  "fixed": "none",
                  "hidden": false,
                  "include": true,
                  "name": "end",
                  "order": 2,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "End",
                  "width": 150,
                  "wordWrapEnabled": false
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "equipmentPath",
                  "dataFormat": "",
                  "dataType": "string",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "equipmentPath",
                  "order": 3,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Equipment Path",
                  "width": 100,
                  "wordWrapEnabled": false
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "originalEquipmentPath",
                  "dataFormat": "",
                  "dataType": "string",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "originalEquipmentPath",
                  "order": 4,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Original Equipment Path",
                  "width": 100,
                  "wordWrapEnabled": false
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "equipmentSubpath",
                  "dataFormat": "",
                  "dataType": "string",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "equipmentSubpath",
                  "order": 5,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Equipment Subpath",
                  "width": 100,
                  "wordWrapEnabled": false
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "equipmentName",
                  "dataFormat": "",
                  "dataType": "string",
                  "fixed": "none",
                  "hidden": false,
                  "include": true,
                  "name": "equipmentName",
                  "order": 6,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Equipment Name",
                  "width": 175,
                  "wordWrapEnabled": false
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "reason",
                  "dataFormat": "",
                  "dataType": "string",
                  "fixed": "none",
                  "hidden": false,
                  "include": true,
                  "name": "reason",
                  "order": 7,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Reason",
                  "width": 175,
                  "wordWrapEnabled": true
                },
                {
                  "align": "center",
                  "alignVertical": "middle",
                  "columnName": "code",
                  "dataFormat": "0",
                  "dataType": "number",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "code",
                  "order": 8,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Code",
                  "width": 100,
                  "wordWrapEnabled": false
                },
                {
                  "align": "center",
                  "alignVertical": "middle",
                  "columnName": "duration",
                  "dataFormat": "0:0",
                  "dataType": "number",
                  "fixed": "none",
                  "hidden": false,
                  "include": true,
                  "name": "duration",
                  "order": 9,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Duration",
                  "width": 110,
                  "wordWrapEnabled": false
                },
                {
                  "align": "center",
                  "alignVertical": "middle",
                  "columnName": "isShortStop",
                  "dataFormat": "",
                  "dataType": "boolean",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "isShortStop",
                  "order": 10,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Is Short Stop",
                  "width": 100,
                  "wordWrapEnabled": true
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "note",
                  "dataFormat": "",
                  "dataType": "string",
                  "fixed": "none",
                  "hidden": false,
                  "include": true,
                  "name": "note",
                  "order": 11,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Note",
                  "width": 175,
                  "wordWrapEnabled": true
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "stateTimeStamp",
                  "dataFormat": "yyyy-MM-dd HH:mm:ss",
                  "dataType": "date",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "stateTimeStamp",
                  "order": 12,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "State Time Stamp",
                  "width": 90,
                  "wordWrapEnabled": false
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "endStateTimeStamp",
                  "dataFormat": "yyyy-MM-dd HH:mm:ss",
                  "dataType": "date",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "endStateTimeStamp",
                  "order": 13,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "End State Time Stamp",
                  "width": 90,
                  "wordWrapEnabled": false
                },
                {
                  "align": "center",
                  "alignVertical": "middle",
                  "columnName": "split",
                  "dataFormat": "",
                  "dataType": "boolean",
                  "fixed": "none",
                  "hidden": false,
                  "include": true,
                  "name": "split",
                  "order": 14,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Split",
                  "width": 100,
                  "wordWrapEnabled": true
                },
                {
                  "align": "center",
                  "alignVertical": "middle",
                  "columnName": "canRevertSplit",
                  "dataFormat": "",
                  "dataType": "boolean",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "canRevertSplit",
                  "order": 15,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Can Revert Split",
                  "width": 90,
                  "wordWrapEnabled": true
                },
                {
                  "align": "center",
                  "alignVertical": "middle",
                  "columnName": "occurrenceCount",
                  "dataFormat": "0",
                  "dataType": "number",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "occurrenceCount",
                  "order": 16,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Occurrence Count",
                  "width": 100,
                  "wordWrapEnabled": false
                },
                {
                  "align": "center",
                  "alignVertical": "middle",
                  "columnName": "sequenceNo",
                  "dataFormat": "0",
                  "dataType": "number",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "sequenceNo",
                  "order": 17,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Sequence No",
                  "width": 100,
                  "wordWrapEnabled": false
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "overrideType",
                  "dataFormat": "",
                  "dataType": "string",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "overrideType",
                  "order": 18,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Override Type",
                  "width": 100,
                  "wordWrapEnabled": false
                },
                {
                  "align": "left",
                  "alignVertical": "middle",
                  "columnName": "overrideScope",
                  "dataFormat": "",
                  "dataType": "string",
                  "fixed": "none",
                  "hidden": true,
                  "include": true,
                  "name": "overrideScope",
                  "order": 19,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Override Scope",
                  "width": 100,
                  "wordWrapEnabled": false
                },
                {
                  "align": "center",
                  "alignVertical": "middle",
                  "columnName": "eventOverridden",
                  "dataFormat": "",
                  "dataType": "boolean",
                  "fixed": "none",
                  "hidden": false,
                  "include": true,
                  "name": "eventOverridden",
                  "order": 20,
                  "searchEnabled": true,
                  "sortingEnabled": true,
                  "title": "Event Overridden",
                  "width": 150,
                  "wordWrapEnabled": true
                }
              ],
              "toolbarStyle": {
                "backgroundColor": "#004A98",
                "fontFamily": "Roboto",
                "fontSize": 15,
                "fontWeight": "normal",
                "paddingLeft": 10
              },
              "tooltipStyle": {
                "fontSize": 15
              },
              "unknownStateAsUnplannedDownTime": true
            },
            "type": "mes.oee.downtimeTable"
          }
        ],
        "meta": {
          "name": "runtime"
        },
        "position": {
          "basis": "200px",
          "grow": 1
        },
        "propConfig": {
          "position.display": {
            "binding": {
              "config": {
                "expression": "!{view.params.configuring}"
              },
              "type": "expr"
            }
          }
        },
        "props": {
          "style": {
            "overflow": "visible"
          }
        },
        "type": "ia.container.flex"
      },
      {
        "meta": {
          "name": "configuration"
        },
        "position": {
          "basis": "320px",
          "grow": 1
        },
        "propConfig": {
          "position.display": {
            "binding": {
              "config": {
                "path": "view.params.configuring"
              },
              "type": "property"
            }
          }
        },
        "props": {
          "params": {
            "equipmentPathIn": "",
            "equipmentPathOut": "",
            "timePeriodIn": "",
            "timePeriodOut": "",
            "titleIn": "",
            "titleOut": ""
          },
          "path": "Page/Widgets/Configuration/Equipment Path, Time Period, Title"
        },
        "type": "ia.display.view"
      }
    ],
    "meta": {
      "name": "root"
    },
    "props": {
      "direction": "column",
      "style": {
        "overflow": "visible"
      }
    },
    "type": "ia.container.flex"
  }
}